# std::__detail Namespace Reference
[Random Number Generation]

## Detailed Description

Implementation details not part of the namespace std interface.

## Classes

- struct _Default_ranged_hash
- struct _Hash_code_base< _Key, _Value, _ExtractKey, _Equal, _H1, _H2, _Default_ranged_hash, false >
- struct _Hash_code_base< _Key, _Value, _ExtractKey, _Equal, _H1, _H2, _Default_ranged_hash, true >
- struct _Hash_code_base< _Key, _Value, _ExtractKey, _Equal, _H1, _H2, _Hash, false >
- struct _Hash_node< _Value, false >
- struct _Hash_node< _Value, true >
- struct _Hashtable_const_iterator
- struct _Hashtable_iterator
- struct _Hashtable_iterator_base
- struct _Map_base
- struct _Map_base< _Key, _Pair, std::_Select1st< _Pair >, false, _Hashtable >
- struct _Map_base< _Key, _Pair, std::_Select1st< _Pair >, true, _Hashtable >
- struct _Mod
- struct _Mod< _Tp, __a, __c, __m, true >
- struct _Mod_range_hashing
- struct _Node_const_iterator
- struct _Node_iterator
- struct _Node_iterator_base
- struct _Prime_rehash_policy
- struct _Rehash_base
- struct _Rehash_base< _Prime_rehash_policy, _Hashtable >

## Functions

- template<class _Iterator> std::iterator_traits< _Iterator
  >::difference_type __distance_fw (_Iterator __first, _Iterator __last)
- template<class _Iterator> std::iterator_traits< _Iterator
  >::difference_type __distance_fw (_Iterator __first, _Iterator __last, std::forward_iterator_tag)
- template<class _Iterator> std::iterator_traits< _Iterator
  >::difference_type __distance_fw (_Iterator __first, _Iterator __last, std::input_iterator_tag)
- template<typename _RAIter, typename _Tp> _RAIter __lower_bound (_RAIter __first, _RAIter __last, const _Tp &__val)
- template<typename _Value, bool __cache> bool operator!= (const _Hashtable_iterator_base< _Value, __cache > &__x, const _Hashtable_iterator_base< _Value, __cache > &__y)
- template<typename _Value, bool __cache> bool operator!= (const _Node_iterator_base< _Value, __cache > &__x, const _Node_iterator_base< _Value, __cache > &__y)
- template<typename _Value, bool __cache> bool operator== (const _Hashtable_iterator_base< _Value, __cache > &__x, const _Hashtable_iterator_base< _Value, __cache > &__y)
- template<typename _Value, bool __cache> bool operator== (const _Node_iterator_base< _Value, __cache > &__x, const _Node_iterator_base< _Value, __cache > &__y)

## Variables

- const unsigned long __prime_list []